---
title: PaymentResponse.complete()
slug: Web/API/PaymentResponse/complete
tags:
  - API
  - Experimental
  - Method
  - Payment Request
  - Payment Request API
  - PaymentResponse
  - Reference
  - Secure context
  - complete
---
<p>{{securecontext_header}}{{APIRef("Payment Request API")}}</p>

<p><span class="seoSummary">The {{domxref("PaymentRequest")}} method <code><strong>complete()</strong></code> of the <a href="/en-US/docs/Web/API/Payment_Request_API">Payment Request API</a> notifies the {{Glossary("user agent")}} that the user interaction is over, and causes any remaining user interface to be closed.</span> This method must be called after the user accepts the payment request and the {{jsxref("Promise")}} returned by the {{domxref('PaymentRequest.show()')}} method is resolved.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>completePromise</em> = <em>paymentRequest</em>.complete(<em>result</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>result</code> {{optional_inline}}</dt>
 <dd>
 <p>A {{domxref("DOMString")}} indicating the state of the payment operation upon completion. It must be one of the following:</p>

 <dl>
  <dt><code>success</code></dt>
  <dd>The payment was successfully processed. The user agent may or may not present some form of "payment successful" indication to the user.</dd>
  <dt><code>fail</code></dt>
  <dd>The payment was not successfully processed. The failure may or may not be announced to the user by the user agent, depending on its design.</dd>
  <dt><code>unknown</code></dt>
  <dd>The success or failure status of the transaction is unknown or irrelevant, and the user agent should not present any notification, even if it normally would. <em>This is the default value.</em></dd>
 </dl>

 <div class="notecard note">
 <p><strong>Note:</strong> In older versions of the specification, an empty string, <code>""</code>, was used instead of <code>unknown</code> to indicate a completion without a known result state. See the {{anch("Browser compatibility")}} section below for details.</p>
 </div>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Promise")}} which resolves with no input value once the payment interface has been fully closed. If an error occurs, the promise instead rejects, returning one of the exceptions listed below.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>AbortError</code></dt>
 <dd>The document in which the payment request is taking place became inactive while the user interface was shown.</dd>
 <dt><code>InvalidStateError</code></dt>
 <dd>The payment has already completed, or <code>complete()</code> was called while a request to retry the payment is pending. You can't treat a payment as complete after requesting that the payment be tried again.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>The following example sends payment information to a secure server using the <a href="/en-US/docs/Web/API/Fetch_API">Fetch API</a>. It calls <code>complete()</code> with an answer appropriate to the status in the response.</p>

<pre>// Initialization of PaymentRequest arguments are excerpted for the
//   sake of brevity.
var payment = new PaymentRequest(supportedInstruments, details, options);

payment.show().then(function(paymentResponse) {
  var fetchOptions = {
    method: 'POST',
    credentials: include,
    body: JSON.stringify(paymentResponse)
  };
  var serverPaymentRequest = new Request('secure/payment/endpoint');
  fetch(serverPaymentRequest, fetchOptions).then( response =&gt; {
    if (response.status &lt; 400) {
      paymentResponse.complete("success");
    } else {
      paymentResponse.complete("fail");
    };
  }).catch( reason =&gt; {
    paymentResponse.complete("fail");
  });
}).catch(function(err) {
  console.error("Uh oh, something bad happened", err.message);
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Payment','#dom-paymentresponse-complete','PaymentResponse: complete')}}</td>
   <td>{{Spec2('Payment')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_Compatibility">Browser Compatibility</h2>

<div>

<p>{{Compat("api.PaymentResponse.complete")}}</p>
</div>
